Index: gcc/genattr.c
===================================================================
--- gcc/genattr.c	(revision 175852)
+++ gcc/genattr.c	(working copy)
@@ -30,23 +30,15 @@ Software Foundation; either version 3, o
 #include "gensupport.h"
 
 
-static void write_upcase (const char *);
 static void gen_attr (rtx);
 
-static void
-write_upcase (const char *str)
-{
-  for (; *str; str++)
-    putchar (TOUPPER(*str));
-}
-
 static VEC (rtx, heap) *const_attrs, *reservations;
 
 
 static void
 gen_attr (rtx attr)
 {
-  const char *p, *tag;
+  const char *p;
   int is_const = GET_CODE (XEXP (attr, 2)) == CONST;
 
   if (is_const)
@@ -65,23 +57,8 @@ gen_attr (rtx attr)
 	printf ("extern int get_attr_%s (%s);\n", XSTR (attr, 0),
 		(is_const ? "void" : "rtx"));
       else
-	{
-	  printf ("enum attr_%s {", XSTR (attr, 0));
-
-	  while ((tag = scan_comma_elt (&p)) != 0)
-	    {
-	      write_upcase (XSTR (attr, 0));
-	      putchar ('_');
-	      while (tag != p)
-		putchar (TOUPPER (*tag++));
-	      if (*p == ',')
-		fputs (", ", stdout);
-	    }
-	  fputs ("};\n", stdout);
-
-	  printf ("extern enum attr_%s get_attr_%s (%s);\n\n",
-		  XSTR (attr, 0), XSTR (attr, 0), (is_const ? "void" : "rtx"));
-	}
+	printf ("extern enum attr_%s get_attr_%s (%s);\n\n",
+		XSTR (attr, 0), XSTR (attr, 0), (is_const ? "void" : "rtx"));
     }
 
   /* If `length' attribute, write additional function definitions and define
@@ -181,6 +158,7 @@ main (int argc, char **argv)
   puts ("#define GCC_INSN_ATTR_H\n");
 
   puts ("#include \"insn-attr-common.h\"\n");
+  puts ("#include \"insn-attr-enum.h\"\n");
 
   /* For compatibility, define the attribute `alternative', which is just
      a reference to the variable `which_alternative'.  */
Index: gcc/optc-gen.awk
===================================================================
--- gcc/optc-gen.awk	(revision 175852)
+++ gcc/optc-gen.awk	(working copy)
@@ -37,6 +37,7 @@ for (i = 1; i <= n_headers; i++)
 	print "#include " quote headers[i] quote
 print "#include " quote "opts.h" quote
 print "#include " quote "intl.h" quote
+print "#include " quote "insn-attr-enum.h" quote
 print ""
 
 if (n_extra_c_includes > 0) {
Index: gcc/Makefile.in
===================================================================
--- gcc/Makefile.in	(revision 175852)
+++ gcc/Makefile.in	(working copy)
@@ -965,7 +965,7 @@ GCC_H = gcc.h version.h $(DIAGNOSTIC_COR
 GGC_H = ggc.h gtype-desc.h statistics.h
 GGC_INTERNAL_H = ggc-internal.h $(GGC_H)
 TIMEVAR_H = timevar.h timevar.def
-INSN_ATTR_H = insn-attr.h insn-attr-common.h $(INSN_ADDR_H)
+INSN_ATTR_H = insn-attr.h insn-attr-common.h insn-attr-enum.h $(INSN_ADDR_H)
 INSN_ADDR_H = $(srcdir)/insn-addr.h vecprim.h
 C_COMMON_H = c-family/c-common.h c-family/c-common.def \
 	$(SPLAY_TREE_H) $(CPPLIB_H) $(GGC_H) $(DIAGNOSTIC_CORE_H)
@@ -1523,7 +1523,7 @@ BACKEND = main.o @TREEBROWSER@ libbacken
 
 MOSTLYCLEANFILES = insn-flags.h insn-config.h insn-codes.h \
  insn-output.c insn-recog.c insn-emit.c insn-extract.c insn-peep.c \
- insn-attr.h insn-attr-common.h insn-attrtab.c insn-opinit.c \
+ insn-attr.h insn-attr-common.h insn-attr-enum.h insn-attrtab.c insn-opinit.c \
  insn-preds.c insn-constants.h \
  tm-preds.h tm-constrs.h checksum-options \
  tree-check.h min-insn-modes.c insn-modes.c insn-modes.h \
@@ -3589,7 +3589,7 @@ mips-tdump.o : mips-tdump.c $(CONFIG_H)
 
 .PRECIOUS: insn-config.h insn-flags.h insn-codes.h insn-constants.h \
   insn-emit.c insn-recog.c insn-extract.c insn-output.c insn-peep.c \
-  insn-attr.h insn-attr-common.h insn-attrtab.c insn-preds.c
+  insn-attr.h insn-attr-common.h insn-attr-enum.h insn-attrtab.c insn-preds.c
 
 # Dependencies for the md file.  The first time through, we just assume
 # the md file itself and the generated dependency file (in order to get
@@ -3646,8 +3646,8 @@ insn-recog.o : insn-recog.c $(CONFIG_H)
 # The "; @true" construct forces Make to recheck the timestamp on
 # the target file.
 
-simple_rtl_generated_h	= insn-attr.h insn-attr-common.h insn-codes.h \
-			  insn-config.h insn-flags.h
+simple_rtl_generated_h	= insn-attr.h insn-attr-common.h insn-attr-enum.h \
+			  insn-codes.h insn-config.h insn-flags.h
 
 simple_rtl_generated_c	= insn-attrtab.c insn-automata.c insn-emit.c \
 			  insn-extract.c insn-opinit.c insn-output.c \
@@ -3965,6 +3965,8 @@ build/genattr.o : genattr.c $(RTL_BASE_H
   coretypes.h $(GTM_H) errors.h $(READ_MD_H) gensupport.h
 build/genattr-common.o : genattr-common.c $(RTL_BASE_H) $(BCONFIG_H)	\
   $(SYSTEM_H) coretypes.h $(GTM_H) errors.h $(READ_MD_H) gensupport.h
+build/genattr-enum.o : genattr-enum.c $(RTL_BASE_H) $(BCONFIG_H)	\
+  $(SYSTEM_H) coretypes.h $(GTM_H) errors.h $(READ_MD_H) gensupport.h
 build/genattrtab.o : genattrtab.c $(RTL_BASE_H) $(OBSTACK_H)		\
   $(BCONFIG_H) $(SYSTEM_H) coretypes.h $(GTM_H) errors.h $(GGC_H)	\
   $(READ_MD_H) gensupport.h vecprim.h
@@ -4024,8 +4026,8 @@ build/genhooks.o : genhooks.c $(TARGET_D
 # even if GCC is being compiled to run on some other machine.
 
 # All these programs use the RTL reader ($(BUILD_RTL)).
-genprogrtl = attr attr-common attrtab automata codes conditions config emit \
-	     extract flags opinit output peep preds recog
+genprogrtl = attr attr-common attr-enum attrtab automata codes conditions \
+	     config emit extract flags opinit output peep preds recog
 $(genprogrtl:%=build/gen%$(build_exeext)): $(BUILD_RTL)
 
 # All these programs use the MD reader ($(BUILD_MD)).
Index: gcc/genattr-enum.c
===================================================================
--- gcc/genattr-enum.c	(revision 175852)
+++ gcc/genattr-enum.c	(working copy)
@@ -2,6 +2,7 @@
    Copyright (C) 1991, 1994, 1996, 1998, 1999, 2000, 2003, 2004, 2007, 2008,
    2010, 2011  Free Software Foundation, Inc.
    Contributed by Richard Kenner (kenner@vlsi1.ultra.nyu.edu)
+   Copyright (C) 2011 Embecosm Limited.
 
 This file is part of GCC.
 
@@ -40,31 +41,16 @@ write_upcase (const char *str)
     putchar (TOUPPER(*str));
 }
 
-static VEC (rtx, heap) *const_attrs, *reservations;
-
-
 static void
 gen_attr (rtx attr)
 {
   const char *p, *tag;
-  int is_const = GET_CODE (XEXP (attr, 2)) == CONST;
-
-  if (is_const)
-    VEC_safe_push (rtx, heap, const_attrs, attr);
-
-  printf ("#define HAVE_ATTR_%s\n", XSTR (attr, 0));
 
   /* If numeric attribute, don't need to write an enum.  */
-  if (GET_CODE (attr) == DEFINE_ENUM_ATTR)
-    printf ("extern enum %s get_attr_%s (%s);\n\n",
-	    XSTR (attr, 1), XSTR (attr, 0), (is_const ? "void" : "rtx"));
-  else
+  if (GET_CODE (attr) != DEFINE_ENUM_ATTR)
     {
       p = XSTR (attr, 1);
-      if (*p == '\0')
-	printf ("extern int get_attr_%s (%s);\n", XSTR (attr, 0),
-		(is_const ? "void" : "rtx"));
-      else
+      if (*p != '\0')
 	{
 	  printf ("enum attr_%s {", XSTR (attr, 0));
 
@@ -78,115 +64,22 @@ gen_attr (rtx attr)
 		fputs (", ", stdout);
 	    }
 	  fputs ("};\n", stdout);
-
-	  printf ("extern enum attr_%s get_attr_%s (%s);\n\n",
-		  XSTR (attr, 0), XSTR (attr, 0), (is_const ? "void" : "rtx"));
 	}
     }
-
-  /* If `length' attribute, write additional function definitions and define
-     variables used by `insn_current_length'.  */
-  if (! strcmp (XSTR (attr, 0), "length"))
-    {
-      puts ("\
-extern void shorten_branches (rtx);\n\
-extern int insn_default_length (rtx);\n\
-extern int insn_min_length (rtx);\n\
-extern int insn_variable_length_p (rtx);\n\
-extern int insn_current_length (rtx);\n\n\
-#include \"insn-addr.h\"\n");
-    }
-}
-
-/* Check that attribute NAME is used in define_insn_reservation condition
-   EXP.  Return true if it is.  */
-static bool
-check_tune_attr (const char *name, rtx exp)
-{
-  switch (GET_CODE (exp))
-    {
-    case AND:
-      if (check_tune_attr (name, XEXP (exp, 0)))
-	return true;
-      return check_tune_attr (name, XEXP (exp, 1));
-
-    case IOR:
-      return (check_tune_attr (name, XEXP (exp, 0))
-	      && check_tune_attr (name, XEXP (exp, 1)));
-
-    case EQ_ATTR:
-      return strcmp (XSTR (exp, 0), name) == 0;
-
-    default:
-      return false;
-    }
-}
-
-/* Try to find a const attribute (usually cpu or tune) that is used
-   in all define_insn_reservation conditions.  */
-static bool
-find_tune_attr (rtx exp)
-{
-  unsigned int i;
-  rtx attr;
-
-  switch (GET_CODE (exp))
-    {
-    case AND:
-    case IOR:
-      if (find_tune_attr (XEXP (exp, 0)))
-	return true;
-      return find_tune_attr (XEXP (exp, 1));
-
-    case EQ_ATTR:
-      if (strcmp (XSTR (exp, 0), "alternative") == 0)
-	return false;
-
-      FOR_EACH_VEC_ELT (rtx, const_attrs, i, attr)
-	if (strcmp (XSTR (attr, 0), XSTR (exp, 0)) == 0)
-	  {
-	    unsigned int j;
-	    rtx resv;
-
-	    FOR_EACH_VEC_ELT (rtx, reservations, j, resv)
-	      if (! check_tune_attr (XSTR (attr, 0), XEXP (resv, 2)))
-		return false;
-	    return true;
-	  }
-      return false;
-
-    default:
-      return false;
-    }
 }
 
 int
 main (int argc, char **argv)
 {
   rtx desc;
-  int have_delay = 0;
-  int have_annul_true = 0;
-  int have_annul_false = 0;
-  int num_insn_reservations = 0;
-  int i;
-
-  progname = "genattr";
 
   if (!init_rtx_reader_args (argc, argv))
     return (FATAL_EXIT_CODE);
 
-  puts ("/* Generated automatically by the program `genattr'");
+  puts ("/* Generated automatically by the program `genattr-enum'");
   puts ("   from the machine description file `md'.  */\n");
-  puts ("#ifndef GCC_INSN_ATTR_H");
-  puts ("#define GCC_INSN_ATTR_H\n");
-
-  puts ("#include \"insn-attr-common.h\"\n");
-
-  /* For compatibility, define the attribute `alternative', which is just
-     a reference to the variable `which_alternative'.  */
-
-  puts ("#define HAVE_ATTR_alternative");
-  puts ("#define get_attr_alternative(insn) which_alternative");
+  puts ("#ifndef GCC_INSN_ATTR_ENUM_H");
+  puts ("#define GCC_INSN_ATTR_ENUM_H\n");
 
   /* Read the machine description.  */
 
@@ -201,182 +94,9 @@ main (int argc, char **argv)
       if (GET_CODE (desc) == DEFINE_ATTR
 	  || GET_CODE (desc) == DEFINE_ENUM_ATTR)
 	gen_attr (desc);
-
-      else if (GET_CODE (desc) == DEFINE_DELAY)
-        {
-	  if (! have_delay)
-	    {
-	      printf ("extern int num_delay_slots (rtx);\n");
-	      printf ("extern int eligible_for_delay (rtx, int, rtx, int);\n\n");
-	      printf ("extern int const_num_delay_slots (rtx);\n\n");
-	      have_delay = 1;
-	    }
-
-	  for (i = 0; i < XVECLEN (desc, 1); i += 3)
-	    {
-	      if (XVECEXP (desc, 1, i + 1) && ! have_annul_true)
-		{
-		  printf ("#define ANNUL_IFTRUE_SLOTS\n");
-		  printf ("extern int eligible_for_annul_true (rtx, int, rtx, int);\n");
-		  have_annul_true = 1;
-		}
-
-	      if (XVECEXP (desc, 1, i + 2) && ! have_annul_false)
-		{
-		  printf ("#define ANNUL_IFFALSE_SLOTS\n");
-		  printf ("extern int eligible_for_annul_false (rtx, int, rtx, int);\n");
-		  have_annul_false = 1;
-		}
-	    }
-        }
-
-      else if (GET_CODE (desc) == DEFINE_INSN_RESERVATION)
-	{
-	  num_insn_reservations++;
-	  VEC_safe_push (rtx, heap, reservations, desc);
-	}
     }
 
-  if (num_insn_reservations > 0)
-    {
-      bool has_tune_attr
-	= find_tune_attr (XEXP (VEC_index (rtx, reservations, 0), 2));
-      /* Output interface for pipeline hazards recognition based on
-	 DFA (deterministic finite state automata.  */
-      printf ("\n/* DFA based pipeline interface.  */");
-      printf ("\n#ifndef AUTOMATON_ALTS\n");
-      printf ("#define AUTOMATON_ALTS 0\n");
-      printf ("#endif\n\n");
-      printf ("\n#ifndef AUTOMATON_STATE_ALTS\n");
-      printf ("#define AUTOMATON_STATE_ALTS 0\n");
-      printf ("#endif\n\n");
-      printf ("#ifndef CPU_UNITS_QUERY\n");
-      printf ("#define CPU_UNITS_QUERY 0\n");
-      printf ("#endif\n\n");
-      /* Interface itself: */
-      if (has_tune_attr)
-	{
-	  printf ("/* Initialize fn pointers for internal_dfa_insn_code\n");
-	  printf ("   and insn_default_latency.  */\n");
-	  printf ("extern void init_sched_attrs (void);\n\n");
-	  printf ("/* Internal insn code number used by automata.  */\n");
-	  printf ("extern int (*internal_dfa_insn_code) (rtx);\n\n");
-	  printf ("/* Insn latency time defined in define_insn_reservation. */\n");
-	  printf ("extern int (*insn_default_latency) (rtx);\n\n");
-	}
-      else
-	{
-	  printf ("#define init_sched_attrs() do { } while (0)\n\n");
-	  printf ("/* Internal insn code number used by automata.  */\n");
-	  printf ("extern int internal_dfa_insn_code (rtx);\n\n");
-	  printf ("/* Insn latency time defined in define_insn_reservation. */\n");
-	  printf ("extern int insn_default_latency (rtx);\n\n");
-	}
-      printf ("/* Return nonzero if there is a bypass for given insn\n");
-      printf ("   which is a data producer.  */\n");
-      printf ("extern int bypass_p (rtx);\n\n");
-      printf ("/* Insn latency time on data consumed by the 2nd insn.\n");
-      printf ("   Use the function if bypass_p returns nonzero for\n");
-      printf ("   the 1st insn. */\n");
-      printf ("extern int insn_latency (rtx, rtx);\n\n");
-      printf ("/* Maximal insn latency time possible of all bypasses for this insn.\n");
-      printf ("   Use the function if bypass_p returns nonzero for\n");
-      printf ("   the 1st insn. */\n");
-      printf ("extern int maximal_insn_latency (rtx);\n\n");
-      printf ("\n#if AUTOMATON_ALTS\n");
-      printf ("/* The following function returns number of alternative\n");
-      printf ("   reservations of given insn.  It may be used for better\n");
-      printf ("   insns scheduling heuristics. */\n");
-      printf ("extern int insn_alts (rtx);\n\n");
-      printf ("#endif\n\n");
-      printf ("/* Maximal possible number of insns waiting results being\n");
-      printf ("   produced by insns whose execution is not finished. */\n");
-      printf ("extern const int max_insn_queue_index;\n\n");
-      printf ("/* Pointer to data describing current state of DFA.  */\n");
-      printf ("typedef void *state_t;\n\n");
-      printf ("/* Size of the data in bytes.  */\n");
-      printf ("extern int state_size (void);\n\n");
-      printf ("/* Initiate given DFA state, i.e. Set up the state\n");
-      printf ("   as all functional units were not reserved.  */\n");
-      printf ("extern void state_reset (state_t);\n");
-      printf ("/* The following function returns negative value if given\n");
-      printf ("   insn can be issued in processor state described by given\n");
-      printf ("   DFA state.  In this case, the DFA state is changed to\n");
-      printf ("   reflect the current and future reservations by given\n");
-      printf ("   insn.  Otherwise the function returns minimal time\n");
-      printf ("   delay to issue the insn.  This delay may be zero\n");
-      printf ("   for superscalar or VLIW processors.  If the second\n");
-      printf ("   parameter is NULL the function changes given DFA state\n");
-      printf ("   as new processor cycle started.  */\n");
-      printf ("extern int state_transition (state_t, rtx);\n");
-      printf ("\n#if AUTOMATON_STATE_ALTS\n");
-      printf ("/* The following function returns number of possible\n");
-      printf ("   alternative reservations of given insn in given\n");
-      printf ("   DFA state.  It may be used for better insns scheduling\n");
-      printf ("   heuristics.  By default the function is defined if\n");
-      printf ("   macro AUTOMATON_STATE_ALTS is defined because its\n");
-      printf ("   implementation may require much memory.  */\n");
-      printf ("extern int state_alts (state_t, rtx);\n");
-      printf ("#endif\n\n");
-      printf ("extern int min_issue_delay (state_t, rtx);\n");
-      printf ("/* The following function returns nonzero if no one insn\n");
-      printf ("   can be issued in current DFA state. */\n");
-      printf ("extern int state_dead_lock_p (state_t);\n");
-      printf ("/* The function returns minimal delay of issue of the 2nd\n");
-      printf ("   insn after issuing the 1st insn in given DFA state.\n");
-      printf ("   The 1st insn should be issued in given state (i.e.\n");
-      printf ("    state_transition should return negative value for\n");
-      printf ("    the insn and the state).  Data dependencies between\n");
-      printf ("    the insns are ignored by the function.  */\n");
-      printf
-	("extern int min_insn_conflict_delay (state_t, rtx, rtx);\n");
-      printf ("/* The following function outputs reservations for given\n");
-      printf ("   insn as they are described in the corresponding\n");
-      printf ("   define_insn_reservation.  */\n");
-      printf ("extern void print_reservation (FILE *, rtx);\n");
-      printf ("\n#if CPU_UNITS_QUERY\n");
-      printf ("/* The following function returns code of functional unit\n");
-      printf ("   with given name (see define_cpu_unit). */\n");
-      printf ("extern int get_cpu_unit_code (const char *);\n");
-      printf ("/* The following function returns nonzero if functional\n");
-      printf ("   unit with given code is currently reserved in given\n");
-      printf ("   DFA state.  */\n");
-      printf ("extern int cpu_unit_reservation_p (state_t, int);\n");
-      printf ("#endif\n\n");
-      printf ("/* The following function returns true if insn\n");
-      printf ("   has a dfa reservation.  */\n");
-      printf ("extern bool insn_has_dfa_reservation_p (rtx);\n\n");
-      printf ("/* Clean insn code cache.  It should be called if there\n");
-      printf ("   is a chance that condition value in a\n");
-      printf ("   define_insn_reservation will be changed after\n");
-      printf ("   last call of dfa_start.  */\n");
-      printf ("extern void dfa_clean_insn_cache (void);\n\n");
-      printf ("extern void dfa_clear_single_insn_cache (rtx);\n\n");
-      printf ("/* Initiate and finish work with DFA.  They should be\n");
-      printf ("   called as the first and the last interface\n");
-      printf ("   functions.  */\n");
-      printf ("extern void dfa_start (void);\n");
-      printf ("extern void dfa_finish (void);\n");
-    }
-  else
-    {
-      /* Otherwise we do no scheduling, but we need these typedefs
-	 in order to avoid uglifying other code with more ifdefs.  */
-      printf ("typedef void *state_t;\n\n");
-    }
-
-  /* Output flag masks for use by reorg.
-
-     Flags are used to hold branch direction and prediction information
-     for use by eligible_for_...  */
-  printf("\n#define ATTR_FLAG_forward\t0x1\n");
-  printf("#define ATTR_FLAG_backward\t0x2\n");
-  printf("#define ATTR_FLAG_likely\t0x4\n");
-  printf("#define ATTR_FLAG_very_likely\t0x8\n");
-  printf("#define ATTR_FLAG_unlikely\t0x10\n");
-  printf("#define ATTR_FLAG_very_unlikely\t0x20\n");
-
-  puts("\n#endif /* GCC_INSN_ATTR_H */");
+  puts("\n#endif /* GCC_INSN_ATTR_ENUM_H */");
 
   if (ferror (stdout) || fflush (stdout) || fclose (stdout))
     return FATAL_EXIT_CODE;